import { Router, RouterModule } from '@angular/router';
import { Location, CommonModule } from '@angular/common';
import { __awaiter } from 'tslib';
import { HttpClient, HttpParams } from '@angular/common/http';
import { Component, Input, EventEmitter, Output, NgModule, Injectable, Directive, ElementRef, ViewChild, ViewContainerRef, ChangeDetectorRef, ComponentFactoryResolver, defineInjectable, inject } from '@angular/core';
import { filter, map, catchError, first, switchMap } from 'rxjs/operators';
import { Subject, throwError, of } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CustomMenuComponent {
    constructor() {
        this.horizontal = false;
        this.autoReset = true;
        this.onItemClick = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // this.menuItems = [
        //     {
        //         label: 'Dashboard', icon: 'dashboard',
        //         items: [
        //             {label: 'Invoice Dashboard', icon: 'dashboard',  routerLink: ['/cmx-loader']},
        //             {label: 'Grid', icon: 'dashboard',  routerLink: ['/cmx-loader1']},
        //             {label: 'Dashboard-3', icon: 'dashboard',  routerLink: ['/admin/pages/']},
        //         ]
        //     },
        //     {
        //         label: 'Cargo Messenger', icon: 'question_answer',
        //         items: [
        //             {label: 'Messenger ', /*routerLink: ['/']*/},
        //             {label: 'Proovv', routerLink: ['/admin/pages/proovv']}
        //         ]
        //     },
        //     {
        //         label: 'Cargo Explorer', icon: 'group',
        //         items: [
        //             {label: 'Task Manager ', /*routerLink: ['/']*/},
        //             // {label: 'Operations', routerLink: ['/admin/pages/charts']},
        //             {label: 'Prime Charts', routerLink: ['/admin/pages/charts-prime']},
        //             {label: 'Charts', routerLink: ['/admin/pages/charts']}
        //         ]
        //     },
        //     // {
        //     //     label: 'Settings', icon: 'settings_application',
        //     //     items: [
        //     //         {label: 'DHL', icon: 'brush', command: (event) => {this.changeTheme('dhl')}},
        //     //         {label: 'CargoMatrix', icon: 'brush', command: (event) => {this.changeTheme('cargomatrix')}},
        //     //         {label: 'Indigo - Pink', icon: 'brush', command: (event) => {this.changeTheme('indigo')}},
        //     //         {label: 'Brown - Green', icon: 'brush', command: (event) => {this.changeTheme('brown')}},
        //     //         {label: 'Blue - Amber', icon: 'brush', command: (event) => {this.changeTheme('blue')}},
        //     //         {label: 'Blue Grey - Green', icon: 'brush', command: (event) => {this.changeTheme('blue-grey')}},
        //     //         {label: 'Dark - Blue', icon: 'brush', command: (event) => {this.changeTheme('dark-blue')}},
        //     //         {label: 'Dark - Green', icon: 'brush', command: (event) => {this.changeTheme('dark-green')}},
        //     //         {label: 'Green - Yellow', icon: 'brush', command: (event) => {this.changeTheme('green')}},
        //     //         {label: 'Purple - Cyan', icon: 'brush', command: (event) => {this.changeTheme('purple-cyan')}},
        //     //         {label: 'Purple - Amber', icon: 'brush', command: (event) => {this.changeTheme('purple-amber')}},
        //     //         {label: 'Teal - Lime', icon: 'brush', command: (event) => {this.changeTheme('teal')}},
        //     //         {label: 'Cyan - Amber', icon: 'brush', command: (event) => {this.changeTheme('cyan')}},
        //     //         {label: 'Grey - Deep Orange', icon: 'brush', command: (event) => {this.changeTheme('grey')}}
        //     //     ]
        //     // },
        // ];
    }
    /**
     * @param {?} e
     * @return {?}
     */
    itemClick(e) {
        if (this.autoReset)
            this.reset = !e.item.items;
        this.onItemClick.emit(e);
    }
}
CustomMenuComponent.decorators = [
    { type: Component, args: [{
                selector: 'custom-menu',
                template: `
        <ul class="navbar navbar-nav px-2" *ngIf="menuItems?.length">
            <submenu [item]="menuItems" (onItemClick)="itemClick($event)" root="true" [reset]="reset"> </submenu>
        </ul>
    `,
                host: {
                    '[class.horizontal-menu]': 'horizontal'
                },
                styles: [":host{display:block;width:100%}:host cmx-submenu{width:100%}:host cmx-submenu ::ng-deep .active-link{background-color:var(--primary)}:host cmx-submenu ::ng-deep .dropdown-item{padding:0 .5rem!important}:host.horizontal-menu cmx-submenu{display:flex}:host.horizontal-menu cmx-submenu ::ng-deep .dropdown-menu{position:absolute}"]
            }] }
];
/** @nocollapse */
CustomMenuComponent.ctorParameters = () => [];
CustomMenuComponent.propDecorators = {
    menuItems: [{ type: Input }],
    horizontal: [{ type: Input }],
    autoReset: [{ type: Input }],
    reset: [{ type: Input }],
    onItemClick: [{ type: Output }]
};
// <li class="nav-item active  w-100">
// <a class="dropdown-item" href="#">Action</a>
// </li>
// <li class="nav-item  w-100">
// <a class="dropdown-item" href="#">Another action</a>
// </li>
// <li class="nav-item  w-100">
// <div class="dropdown-divider"></div>
// </li>
// <li class="nav-item  w-100">
// <a class="dropdown-item" href="#">Something else here</a>
// </li>
// </li>
// <li class="nav-item  w-100">
// <a class="nav-link" href="#">Link</a>
// </li>
// <li class="nav-item dropdown  w-100">
// <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
//   Dropdown
// </a>
// <div class="dropdown-menu" aria-labelledby="navbarDropdown">
//   <a class="dropdown-item" href="#">Action</a>
//   <a class="dropdown-item" href="#">Another action</a>
//   <div class="dropdown-divider"></div>
//   <a class="dropdown-item" href="#">Something else here</a>
// </div>
// </li>
// <li class="nav-item  w-100">
// <a class="nav-link disabled" href="#">Disabled</a>
// </li>
//     <li [ngClass]="{'active-menuitem': isActive(i), 'no-submenu-child': !child?.items?.length}" *ngIf="child.visible === false ? false : true">
//         <a [href]="child.url||'#'" (click)="itemClick($event,child,i)" class="ripplelink" *ngIf="!child.routerLink" [attr.tabindex]="!visible ? '-1' : null" [attr.target]="child.target">
//             <i *ngIf="child.icon" class="{{child.icon}}"></i>
//             <img *ngIf="child.iconSrc" [src]="child.iconSrc"/>
//             <span>{{child.label}}</span>
//             <i class="faw faw-chevron-down" *ngIf="child.items"></i>
//         </a>
//         <a (click)="itemClick($event,child,i)" class="ripplelink" *ngIf="child.routerLink"
//             [routerLink]="child.routerLink" routerLinkActive="active-menuitem-routerlink" [routerLinkActiveOptions]="{exact: false}" [attr.tabindex]="!visible ? '-1' : null" [attr.target]="child.target">
//             <i *ngIf="child.icon" class="{{child.icon}}"></i>
//             <img *ngIf="child.iconSrc" [src]="child.iconSrc"/>
//             <span>{{child.label}}</span>
//             <i class="faw faw-chevron-down" *ngIf="child.items">keyboard_arrow_down</i>
//         </a>
//         <ul *ngIf="child.items" >
//             <cmx-submenu [item]="child" (onItemClick)="onItemClick.emit($event)" [visible]="isActive(i)" [reset]="reset"> </cmx-submenu>
//         </ul>
//     </li>
class SubMenu {
    /**
     * @param {?} router
     * @param {?} location
     */
    constructor(router, location) {
        this.router = router;
        this.location = location;
        this.onItemClick = new EventEmitter();
    }
    /**
     * @param {?} event
     * @param {?} item
     * @param {?} index
     * @return {?}
     */
    itemClick(event, item, index) {
        //avoid processing disabled items
        if (item.disabled) {
            event.preventDefault();
            return true;
        }
        //activate current item and deactivate active sibling if any
        this.activeIndex = (this.activeIndex === index) ? null : index;
        //execute command
        if (item.action) ;
        //prevent hash change
        if (item.items || (!item.url && !item.routerLink)) {
            event.preventDefault();
        }
        this.onItemClick.emit({ event: event, item: item, index: index });
    }
    /**
     * @param {?} index
     * @return {?}
     */
    isActive(index) {
        return this.activeIndex === index;
    }
    /**
     * @return {?}
     */
    get reset() {
        return this._reset;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set reset(val) {
        this._reset = val;
        if (this._reset) {
            this.activeIndex = null;
        }
    }
}
SubMenu.decorators = [
    { type: Component, args: [{
                selector: 'submenu',
                template: `
    <ng-template ngFor let-child let-i="index" [ngForOf]="(root ? item : item.items)">

      <li class="nav-item" routerLinkActive="active" [routerLinkActiveOptions]="{exact: false}" [ngClass]="{'active': isActive(i), 'dropdown': child.items, 'dropdown-item': !root && child.label, 'dropdown-divider': !child.items && !root && !child.routerLink && !child.url && !child.label  }">

        <a *ngIf="child.routerLink" id="sub-menu-{{i}}" [ngClass]="{'dropdown-toggle': child.items }" (click)="itemClick($event,child,i)"
          [routerLink]="child.routerLink" routerLinkActive="active-link" [routerLinkActiveOptions]="{exact: false}"
          class="nav-link p-2" href="#"
          [attr.target]="child.target" [attr.role]="child.items ? 'button' : null" [attr.data-toggle]="child.items ? 'dropdown' : null"
          [attr.aria-haspopup]="child.items ? true : null" [attr.aria-expanded]="child.items ? false : null">
          <i *ngIf="child.icon" class="{{child.icon}}"></i>
          <img *ngIf="child.iconSrc" [src]="child.iconSrc" />
          <span>{{child.label}}</span>
        </a>

        <a *ngIf="!child.routerLink && child.label" id="sub-menu-{{i}}" [ngClass]="{'dropdown-toggle': child.items }" (click)="itemClick($event,child,i)"
          class="nav-link p-2" [href]="child.url || '#'"
          [attr.target]="child.target" [attr.role]="child.items ? 'button' : null" [attr.data-toggle]="child.items ? 'dropdown' : null"
          [attr.aria-haspopup]="child.items ? true : null" [attr.aria-expanded]="child.items ? false : null">
          <i *ngIf="child.icon" class="{{child.icon}}"></i>
          <img *ngIf="child.iconSrc" [src]="child.iconSrc" />
          <span>{{child.label}}</span>
        </a>

        <ul *ngIf="child.items" class="dropdown-menu" [attr.aria-labelledby]="'sub-menu-' + i">
          <submenu [item]="child" (onItemClick)="onItemClick.emit($event)" [reset]="reset"> </submenu>
        </ul>

      </li>

    </ng-template>
    `
            }] }
];
/** @nocollapse */
SubMenu.ctorParameters = () => [
    { type: Router },
    { type: Location }
];
SubMenu.propDecorators = {
    onItemClick: [{ type: Output }],
    item: [{ type: Input }],
    root: [{ type: Input }],
    reset: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CmxMenuModule {
}
CmxMenuModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    RouterModule
                ],
                declarations: [
                    CustomMenuComponent,
                    SubMenu
                ],
                exports: [
                    CustomMenuComponent,
                    SubMenu
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const ObserveType = {
    "once": 0, "auto": 1,
};
ObserveType[ObserveType["once"]] = "once";
ObserveType[ObserveType["auto"]] = "auto";
class ImagesObserver {
    constructor() {
        this.options = {
            // If the image gets within 50px in the Y axis, start the download.
            root: null,
            // Page as root
            rootMargin: '0px',
            threshold: 0.1
        };
        this.observeType = ObserveType.once;
        this.onObserve = (/**
         * @return {?}
         */
        () => { });
        if ('IntersectionObserver' in window)
            this.observer = new IntersectionObserver(this.handleIntersection.bind(this), this.options);
    }
    /**
     * @private
     * @param {?} url
     * @return {?}
     */
    fetchImage(url) {
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        (resolve, reject) => {
            /** @type {?} */
            const image = new Image();
            image.src = url;
            image.onload = resolve;
            image.onerror = reject;
        }));
    }
    /**
     * @private
     * @param {?} image
     * @return {?}
     */
    loadImage(image) {
        /** @type {?} */
        const src = image.lazySrc;
        return this.fetchImage(src).then((/**
         * @return {?}
         */
        () => {
            image.src = src;
        }));
    }
    /**
     * @private
     * @param {?} entries
     * @param {?} observer
     * @return {?}
     */
    handleIntersection(entries, observer) {
        entries.forEach((/**
         * @param {?} entry
         * @return {?}
         */
        entry => {
            if (entry.intersectionRatio > 0) {
                this.onObserve(entry);
                console.log("observe");
                this.loadImage(entry.target).then((/**
                 * @return {?}
                 */
                () => {
                    if (this.observeType === ObserveType.once && observer && observer.unobserve)
                        observer.unobserve(entry.target);
                }));
            }
        }));
    }
    /**
     * @param {?} images
     * @param {?=} onObserve
     * @param {?=} observeType
     * @return {?}
     */
    observe(images, onObserve, observeType) {
        if (onObserve) {
            this.onObserve = onObserve;
        }
        if (observeType)
            this.observeType = observeType;
        if (this.observer) {
            images.forEach((/**
             * @param {?} img
             * @return {?}
             */
            img => {
                this.observer.observe(img);
            }));
        }
        else {
            Array.from(images).forEach((/**
             * @param {?} image
             * @return {?}
             */
            image => this.loadImage(image)));
        }
    }
    /**
     * @param {?} images
     * @return {?}
     */
    unobserve(images) {
        images.forEach((/**
         * @param {?} img
         * @return {?}
         */
        img => {
            if (this.observer && this.observer.unobserve)
                this.observer.unobserve(img);
        }));
    }
}
ImagesObserver.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ImagesObserver.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LazySrcDirective {
    /**
     * @param {?} elementRef
     * @param {?} imagesObserver
     */
    constructor(elementRef, imagesObserver) {
        this.imagesObserver = imagesObserver;
        this.element = elementRef.nativeElement;
        this.element.lazySrc = this.element.src;
        this.element.src = "";
        this.imagesObserver.observe([this.element]);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.imagesObserver && this.imagesObserver.unobserve)
            this.imagesObserver.unobserve([this.element]);
    }
}
LazySrcDirective.decorators = [
    { type: Directive, args: [{
                selector: "[lazysrc]",
                providers: [ImagesObserver]
            },] }
];
/** @nocollapse */
LazySrcDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: ImagesObserver }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LazySrcDirectiveCoreModule {
}
LazySrcDirectiveCoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                declarations: [
                    LazySrcDirective
                ],
                exports: [
                    LazySrcDirective
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicComponentService {
}
DynamicComponentService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ DynamicComponentService.ngInjectableDef = defineInjectable({ factory: function DynamicComponentService_Factory() { return new DynamicComponentService(); }, token: DynamicComponentService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicComponent {
    /**
     * @param {?} DynamicComponentService
     * @param {?} viewRef
     * @param {?} cdRef
     * @param {?} componentFactoryResolver
     */
    constructor(DynamicComponentService$$1, viewRef, cdRef, componentFactoryResolver) {
        this.DynamicComponentService = DynamicComponentService$$1;
        this.viewRef = viewRef;
        this.cdRef = cdRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.hasLoader = true;
        this.optionsChange = new EventEmitter();
        this.initialized = new EventEmitter();
        this.loader = true;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.init();
    }
    /**
     * @return {?}
     */
    init() {
        this.loader = true;
        if (this.component) {
            /** @type {?} */
            let componentFactory = this.componentFactoryResolver.resolveComponentFactory(typeof this.component === 'string' ? this.DynamicComponentService.dynamicComponentsList[this.component] : this.component);
            this.injectComponent(componentFactory, this.options, this.container);
            this.loader = false;
            if (!this.options) {
                this.options = {};
            }
            this.cdRef.detectChanges();
            this.initialized.emit(this.control);
        }
        else {
            this.loader = false;
            this.cdRef.detectChanges();
            this.initialized.emit(this.control);
        }
    }
    /**
     * @param {?} componentFactory
     * @param {?} componentData
     * @param {?} container
     * @return {?}
     */
    injectComponent(componentFactory, componentData, container) {
        if (componentFactory) {
            /** @type {?} */
            let ref = container.createComponent(componentFactory);
            for (var key in componentData) {
                if (componentData.hasOwnProperty(key)) {
                    ref.instance[key] = componentData[key];
                }
            }
            this.control = ref.instance;
            for (let key in this.control) {
                if (ref.instance.hasOwnProperty(key + "Change")) {
                    ref.instance[key + "Change"].subscribe((/**
                     * @param {?} val
                     * @return {?}
                     */
                    (val) => {
                        this.options[key] = val;
                        this.optionsChange.emit(this.options);
                    }));
                }
            }
            ref.changeDetectorRef.detectChanges();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        const component = changes.component;
        if (component && !component.firstChange && this.container) {
            this.container.remove();
            this.init();
        }
    }
}
DynamicComponent.decorators = [
    { type: Component, args: [{
                selector: 'dynamic',
                template: "<ng-container #cont></ng-container>\r\n<app-loader *ngIf=\"hasLoader && loader\"></app-loader>",
                styles: [":host{display:block}"]
            }] }
];
/** @nocollapse */
DynamicComponent.ctorParameters = () => [
    { type: DynamicComponentService },
    { type: ViewContainerRef },
    { type: ChangeDetectorRef },
    { type: ComponentFactoryResolver }
];
DynamicComponent.propDecorators = {
    container: [{ type: ViewChild, args: ["cont", { read: ViewContainerRef },] }],
    component: [{ type: Input }],
    hasLoader: [{ type: Input }],
    options: [{ type: Input }],
    optionsChange: [{ type: Output }],
    initialized: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoaderComponent {
    constructor() { }
}
LoaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-loader',
                template: "<div class=\"loader-body\">\r\n    <div class=\"loader-content\">\r\n        <div class=\"lds-spinner\">\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n        </div>\r\n    </div>\r\n</div>",
                styles: [".loader-body{position:fixed;width:100%;top:0;z-index:99999999;height:100%;text-align:center!important;left:0;display:flex;align-items:center;justify-content:center;background:rgba(0,0,0,.48)}.lds-spinner{color:official;display:inline-block;position:relative;width:64px;height:64px}.lds-spinner div{transform-origin:32px 32px;-webkit-animation:1.2s linear infinite lds-spinner;animation:1.2s linear infinite lds-spinner}.lds-spinner div:after{content:\" \";display:block;position:absolute;top:8px;left:30px;width:2px;height:12px;border-radius:20%;background:#fff}.lds-spinner div:nth-child(1){transform:rotate(0);-webkit-animation-delay:-1.1s;animation-delay:-1.1s}.lds-spinner div:nth-child(2){transform:rotate(30deg);-webkit-animation-delay:-1s;animation-delay:-1s}.lds-spinner div:nth-child(3){transform:rotate(60deg);-webkit-animation-delay:-.9s;animation-delay:-.9s}.lds-spinner div:nth-child(4){transform:rotate(90deg);-webkit-animation-delay:-.8s;animation-delay:-.8s}.lds-spinner div:nth-child(5){transform:rotate(120deg);-webkit-animation-delay:-.7s;animation-delay:-.7s}.lds-spinner div:nth-child(6){transform:rotate(150deg);-webkit-animation-delay:-.6s;animation-delay:-.6s}.lds-spinner div:nth-child(7){transform:rotate(180deg);-webkit-animation-delay:-.5s;animation-delay:-.5s}.lds-spinner div:nth-child(8){transform:rotate(210deg);-webkit-animation-delay:-.4s;animation-delay:-.4s}.lds-spinner div:nth-child(9){transform:rotate(240deg);-webkit-animation-delay:-.3s;animation-delay:-.3s}.lds-spinner div:nth-child(10){transform:rotate(270deg);-webkit-animation-delay:-.2s;animation-delay:-.2s}.lds-spinner div:nth-child(11){transform:rotate(300deg);-webkit-animation-delay:-.1s;animation-delay:-.1s}.lds-spinner div:nth-child(12){transform:rotate(330deg);-webkit-animation-delay:0s;animation-delay:0s}@-webkit-keyframes lds-spinner{0%{opacity:1}100%{opacity:0}}@keyframes lds-spinner{0%{opacity:1}100%{opacity:0}}"]
            }] }
];
/** @nocollapse */
LoaderComponent.ctorParameters = () => [];
LoaderComponent.propDecorators = {
    openModalButton: [{ type: ViewChild, args: ['openModalButton',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoaderModule {
}
LoaderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [LoaderComponent],
                imports: [],
                exports: [LoaderComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CmxDynamicModule {
}
CmxDynamicModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    LoaderModule
                ],
                declarations: [
                    DynamicComponent
                ],
                exports: [
                    DynamicComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PanelComponent {
    constructor() {
        this.maximizable = true;
        this.maximized = false;
        this.showPanelHeader = true;
        this.iconSrc = '/assets/icons/chart-icon.png';
        this.icon = '';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} e
     * @return {?}
     */
    maximizeContainer(e) {
        this.maximized = !this.maximized;
    }
}
PanelComponent.decorators = [
    { type: Component, args: [{
                selector: 'custom-panel',
                template: "<div #panel class=\"panel\">\r\n  <div class=\"panel-header\" *ngIf=\"showPanelHeader\">\r\n    <div class=\"header-text\">\r\n      <div class=\"icon\">\r\n        <i *ngIf=\"icon\" class=\"{{icon}}\"></i>\r\n        <img *ngIf=\"iconSrc\" [src]=\"iconSrc\" />\r\n      </div>\r\n\r\n      <ng-content select=\".header\"></ng-content>\r\n    </div>\r\n    <div class=\"header-actions vertical-center\">\r\n      <i class=\"fa fa-arrows-alt drag-button\" title=\"Drag/Drop\"></i>\r\n      <button class=\"round-button small no-border\" *ngIf=\"maximizable\" (click)=\"maximizeContainer($event)\">\r\n      </button>\r\n      <!-- \r\n      hint=\"{{maximized ? 'Minimize' : 'Maximize'}}\"\r\n      [icon]=\"maximized ? 'ma ma-fullscreen_exit' : 'ma ma-fullscreen'\" -->\r\n    </div>\r\n  </div>\r\n  <div class=\"panel-content-wrapper\">\r\n    <ng-content select=\".content\"></ng-content>\r\n  </div>\r\n</div>",
                host: { '[class.maximized-panel]': 'maximized' },
                styles: [":host{display:block;height:500px}:host.maximized-panel{position:absolute;left:0;right:0;bottom:0;top:0;margin:0!important;height:auto!important;width:auto!important;padding:0;z-index:3000}:host.maximized-panel>.panel{height:100%}:host.maximized-panel>.panel>.panel-content-wrapper{margin:auto;width:100%;height:100%!important;border:0!important}:host.maximized-panel>.panel>.panel-content-wrapper .content{height:100%!important}:host .panel{height:100%;width:100%;display:flex;flex-direction:column}:host .panel .panel-header{align-items:center;display:flex;justify-content:space-between;border:1px solid #d0d0d0}:host .panel .panel-header .drag-button{font-size:18px;cursor:move;padding-top:3px}:host .panel .panel-header .header-text{display:flex;align-items:center;width:100%;max-width:calc(100% - 20px)}:host .panel .panel-header .header-text .icon{margin-right:5px}:host .panel .panel-header .header-text .icon i{font-size:20px}:host .panel .panel-header .header-text .icon img{width:24px;height:24px}:host .panel .panel-header .header-text .views{display:flex}:host .panel .panel-header .header-text .views .icon{cursor:pointer;box-sizing:border-box}:host .panel .panel-header .header-text .views .icon.selected{box-shadow:0 0 0 2px #d40511;box-sizing:content-box}:host .panel .panel-content-wrapper{height:400px;padding:.625em 1em;overflow:auto!important;box-sizing:border-box;border:1px solid #d0d0d0;border-top:0;overflow-x:hidden!important;background-color:#fff}:host .panel .panel-content-wrapper .dx-button{background:#fff;float:right!important}:host .panel .content{height:100%}:host>.panel .panel-header{min-height:34px;padding:0;background:#fafafa;border-color:rgba(0,0,0,.15);border-bottom:1px solid #e1e1e1;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-filter:none;filter:none;width:100%;font-size:13px;font-family:'Segoe UI','Helvetica Neue',Helvetica,Verdana,sans-serif}:host>.panel .panel-header .header-text{overflow:hidden;-ms-text-overflow:ellipsis;text-overflow:ellipsis;cursor:default;font-weight:400;padding:2px 0 2px 10px}:host>.panel .panel-header .header-text .header{flex:1 1 auto}:host>.panel .panel-header .header-text .header span{color:#5d5d5d}:host>.panel .panel-header .header-actions{vertical-align:top;border-width:0;padding:4px;display:flex}:host>.panel .panel-header .header-actions ::ng-deep .dx-button-content{padding:0}:host>.panel .panel-header .header-actions ::ng-deep .dx-button-content .dx-icon{width:100%;height:100%;line-height:24px;font-size:24px}:host>.panel .panel-header .header-actions ::ng-deep .dx-button-content .dx-icon.ma.ma-fullscreen,:host>.panel .panel-header .header-actions ::ng-deep .dx-button-content .dx-icon.ma.ma-fullscreen_exit{font-size:24px}:host>.panel .panel-header .header-actions .dx-button{width:24px;height:24px;border-radius:0;border:0;background:#fff}:host>.panel .panel-header .header-actions .dx-button:hover{background-color:initial;box-shadow:0 0 0 1px rgba(0,0,0,.15)}:host>.panel .panel-content-wrapper{border-color:rgba(0,0,0,.15)}@media all and (-ms-high-contrast:none),(-ms-high-contrast:active){custom-panel.maximized-panel{position:absolute!important}}"]
            }] }
];
/** @nocollapse */
PanelComponent.ctorParameters = () => [];
PanelComponent.propDecorators = {
    maximizable: [{ type: Input }],
    maximized: [{ type: Input }],
    showPanelHeader: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PanelModule {
}
PanelModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: [
                    PanelComponent
                ],
                exports: [
                    PanelComponent
                ],
                entryComponents: [
                    PanelComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BroadcasterService {
    constructor() {
        this._eventBus = new Subject();
    }
    /**
     * @param {?} key
     * @param {?=} data
     * @return {?}
     */
    broadcast(key, data) {
        this._eventBus.next({ key, data });
    }
    /**
     * @template T
     * @param {?} key
     * @return {?}
     */
    on(key) {
        return this._eventBus.asObservable().pipe(filter((/**
         * @param {?} event
         * @return {?}
         */
        (event) => event.key === key)), map((/**
         * @param {?} event
         * @return {?}
         */
        event => (/** @type {?} */ (event.data)))));
    }
}
BroadcasterService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
BroadcasterService.ctorParameters = () => [];
/** @nocollapse */ BroadcasterService.ngInjectableDef = defineInjectable({ factory: function BroadcasterService_Factory() { return new BroadcasterService(); }, token: BroadcasterService, providedIn: "root" });
class WithEventSubscriptions {
    /**
     * @param {?} broadcasterService
     */
    constructor(broadcasterService) {
        this.subscriptions = [];
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.subscriptions.forEach((/**
         * @param {?} sbc
         * @return {?}
         */
        sbc => {
            sbc.unsubscribe();
        }));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AppConfigService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
    /**
     * @param {?} theme
     * @return {?}
     */
    changeTheme(theme) {
        /** @type {?} */
        let themeLink = (/** @type {?} */ (document.getElementById('theme-css')));
        /** @type {?} */
        let favIconLinl = (/** @type {?} */ (document.getElementById('theme-css-favicon')));
        themeLink.href = 'assets/theme/theme-' + theme + '.css';
        favIconLinl.href = 'assets/images/' + theme + '-favicon.png';
    }
    /**
     * @return {?}
     */
    loadAppConfig() {
        return __awaiter(this, void 0, void 0, /** @this {!AppConfigService} */ function* () {
            try {
                /** @type {?} */
                const configs = yield this.http.get("app.config.json").toPromise();
                this.appConfig = configs;
            }
            catch (err) {
                console.log(err);
            }
        });
    }
}
AppConfigService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AppConfigService.ctorParameters = () => [
    { type: HttpClient }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicActionsService {
    /**
     * @param {?} event
     * @param {?} settings
     */
    constructor(event, settings) {
        this.event = event;
        this.settings = settings;
    }
    /**
     * @param {?} action
     * @param {?=} data
     * @param {?=} event
     * @return {?}
     */
    callAction(action, data, event) {
        if (!action.type || action.type === "event") {
            action.name.split(',').forEach((/**
             * @param {?} name
             * @return {?}
             */
            name => {
                this.event.broadcast(name, this.getParams(action, data));
            }));
        }
        else {
            action.name.split(',').forEach((/**
             * @param {?} name
             * @return {?}
             */
            name => {
                this[action.type][name](this.getParams(action, data), event);
            }));
        }
    }
    /**
     * @private
     * @param {?} action
     * @param {?=} data
     * @return {?}
     */
    getParams(action, data) {
        /** @type {?} */
        let params = null;
        if (action.onlyStaticParams) {
            params = {};
            if (action.params) {
                params = this.copy(action.params);
            }
            if (action.matchParams) {
                for (var key in action.matchParams) {
                    if (data && (data[action.matchParams[key]] || data[action.matchParams[key]] == 0))
                        params[key] = data[action.matchParams[key]];
                }
            }
            return params;
        }
        if (data)
            params = this.copy(data);
        if (action.params) {
            params = params ? Object.assign({}, params, this.copy(action.params)) : this.copy(action.params);
        }
        if (action.matchParams) {
            for (var key in action.matchParams) {
                params[key] = data[action.matchParams[key]];
            }
        }
        return params;
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    copy(obj) {
        if (Array.isArray(obj))
            return obj.map((/**
             * @param {?} item
             * @return {?}
             */
            item => this.copy(item)));
        if (obj && !(obj instanceof Date) && typeof obj === "object") {
            /** @type {?} */
            let copy = {};
            for (const key in obj) {
                if (obj.hasOwnProperty(key)) {
                    copy[key] = this.copy(obj[key]);
                }
            }
            return copy;
        }
        else {
            return obj;
        }
    }
}
DynamicActionsService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
DynamicActionsService.ctorParameters = () => [
    { type: BroadcasterService },
    { type: AppConfigService }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PublicApiCallerService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?=} params
     * @param {?=} reqOpts
     * @return {?}
     */
    get(endpoint, params, reqOpts) {
        return this.http.get(endpoint, generateRequestOptions(reqOpts, params)).pipe(this.processApiResponse());
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    post(endpoint, body, reqOpts) {
        return this.http.post(endpoint, body, generateRequestOptions(reqOpts)).pipe(this.processApiResponse());
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    put(endpoint, body, reqOpts) {
        return this.http.put(endpoint, body, generateRequestOptions(reqOpts)).pipe(this.processApiResponse());
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?=} reqOpts
     * @return {?}
     */
    delete(endpoint, reqOpts) {
        return this.http.delete(endpoint, generateRequestOptions(reqOpts)).pipe(this.processApiResponse());
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    patch(endpoint, body, reqOpts) {
        return this.http.patch(endpoint, body, generateRequestOptions(reqOpts)).pipe(this.processApiResponse());
    }
    /**
     * @template T
     * @return {?}
     */
    processApiResponse() {
        return (/**
         * @param {?} httpResponse$
         * @return {?}
         */
        (httpResponse$) => httpResponse$.pipe(map((/**
         * @param {?} response
         * @return {?}
         */
        response => (/** @type {?} */ (response)))), catchError((/**
         * @param {?} err
         * @return {?}
         */
        (err) => {
            return throwError(err);
        }))));
    }
}
PublicApiCallerService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
PublicApiCallerService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ PublicApiCallerService.ngInjectableDef = defineInjectable({ factory: function PublicApiCallerService_Factory() { return new PublicApiCallerService(inject(HttpClient)); }, token: PublicApiCallerService, providedIn: "root" });
/**
 * @param {?=} reqOpts
 * @param {?=} params
 * @return {?}
 */
function generateRequestOptions(reqOpts = { responseType: 'json', observe: 'body' }, params) {
    if (params) {
        reqOpts.params = new HttpParams();
        for (let k in params) {
            reqOpts.params = reqOpts.params.set(k, params[k]);
        }
    }
    return reqOpts;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PrivateApiCallerService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.accessTokenName = 'token';
    }
    /**
     * @return {?}
     */
    getAuthHeaders() {
        return {
            headers: {
                'Content-Type': 'application/json',
                'Authorization': `Bearer ${localStorage.getItem(this.accessTokenName)}`
            }
        };
    }
    /**
     * @param {?} requestFunc
     * @return {?}
     */
    doPrivateApiRequest(requestFunc) {
        return of(localStorage.getItem(this.accessTokenName)).pipe(first(), filter((/**
         * @param {?} u
         * @return {?}
         */
        u => !!u)), map(this.getAuthHeaders.bind(this)), switchMap(requestFunc), this.processApiResponse());
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?=} params
     * @param {?=} reqOpts
     * @return {?}
     */
    get(endpoint, params, reqOpts) {
        return this.doPrivateApiRequest((/**
         * @param {?} options
         * @return {?}
         */
        options => this.http.get(this.apiUrl + endpoint, Object.assign({}, generateRequestOptions(reqOpts, params), options))));
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    post(endpoint, body, reqOpts) {
        return this.doPrivateApiRequest((/**
         * @param {?} options
         * @return {?}
         */
        options => this.http.post(this.apiUrl + endpoint, body, Object.assign({}, generateRequestOptions(reqOpts), options))));
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    put(endpoint, body, reqOpts) {
        return this.doPrivateApiRequest((/**
         * @param {?} options
         * @return {?}
         */
        options => this.http.put(this.apiUrl + endpoint, body, Object.assign({}, generateRequestOptions(reqOpts), options))));
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?=} reqOpts
     * @return {?}
     */
    delete(endpoint, reqOpts) {
        return this.doPrivateApiRequest((/**
         * @param {?} options
         * @return {?}
         */
        options => this.http.delete(this.apiUrl + endpoint, Object.assign({}, generateRequestOptions(reqOpts), options))));
    }
    /**
     * @template T
     * @param {?} endpoint
     * @param {?} body
     * @param {?=} reqOpts
     * @return {?}
     */
    patch(endpoint, body, reqOpts) {
        return this.doPrivateApiRequest((/**
         * @param {?} options
         * @return {?}
         */
        options => this.http.patch(this.apiUrl + endpoint, body, Object.assign({}, generateRequestOptions(reqOpts), options))));
    }
    /**
     * @template T
     * @return {?}
     */
    processApiResponse() {
        return (/**
         * @param {?} httpResponse$
         * @return {?}
         */
        (httpResponse$) => httpResponse$.pipe(map((/**
         * @param {?} response
         * @return {?}
         */
        response => (/** @type {?} */ (response)))), catchError((/**
         * @param {?} err
         * @return {?}
         */
        (err) => {
            if (err.status === 401) {
                localStorage.removeItem(this.accessTokenName);
                location.reload(true);
            }
            return throwError(err);
        }))));
    }
}
PrivateApiCallerService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
PrivateApiCallerService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ PrivateApiCallerService.ngInjectableDef = defineInjectable({ factory: function PrivateApiCallerService_Factory() { return new PrivateApiCallerService(inject(HttpClient)); }, token: PrivateApiCallerService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function isMobile() {
    return /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)
        || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0, 4));
}
/**
 * @param {?} items
 * @param {?} subArrayName
 * @param {?} cb
 * @return {?}
 */
function recursiveLoop(items, subArrayName, cb) {
    if (Array.isArray(items)) {
        items.some((/**
         * @param {?} item
         * @return {?}
         */
        item => {
            if (cb(item)) {
                return true;
            }
            else {
                recursiveLoop(item[subArrayName], subArrayName, cb);
            }
        }));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const ThemeList = [
    {
        id: 'theme-mobile',
        link: 'assets/theme/theme-mobile.css'
    },
    {
        id: 'theme-desktop',
        link: 'assets/theme/theme-desktop.css'
    }
];
/**
 * @param {?} id
 * @return {?}
 */
function getThemeById(id) {
    return ThemeList.find((/**
     * @param {?} theme
     * @return {?}
     */
    theme => theme.id === id));
}
/**
 * @param {?} id
 * @return {?}
 */
function changeTheme(id) {
    /** @type {?} */
    let themeLink = generateThemeLink();
    if (getThemeById(id)) {
        themeLink.href = getThemeById(id).link;
        localStorage.setItem('currentTheme', getThemeById(id).id);
    }
    else {
        localStorage.removeItem('currentTheme');
        detectThemeByDeviceType();
        throw "Wrong Theme ID";
    }
    /** @type {?} */
    let body = document.getElementsByTagName('body')[0];
    if (id.indexOf('mobile') !== -1) {
        body.className = body.className + ' mobile-theme';
    }
    else if (body.className.indexOf('mobile-theme') !== -1) {
        body.className = body.className.replace(' mobile-theme', '');
    }
}
/**
 * @param {?=} currentThemePriority
 * @return {?}
 */
function detectThemeByDeviceType(currentThemePriority = false) {
    /** @type {?} */
    let currentTheme = getCurrentTheme();
    if (currentThemePriority) {
        changeTheme(currentTheme);
        return true;
    }
    if (isMobile()) {
        if (currentTheme)
            changeTheme(currentTheme.replace('desktop', 'mobile'));
        else
            changeTheme('theme-mobile');
    }
    else {
        if (currentTheme) {
            changeTheme(currentTheme.replace('mobile', 'desktop'));
        }
        else {
            changeTheme('theme-desktop');
        }
    }
}
/**
 * @return {?}
 */
function getCurrentTheme() {
    return localStorage.getItem('currentTheme');
}
/**
 * @return {?}
 */
function generateThemeLink() {
    /** @type {?} */
    let themeLink = (/** @type {?} */ (document.getElementById('theme-css')));
    if (!themeLink) {
        /** @type {?} */
        let head = document.getElementsByTagName('head')[0];
        themeLink = document.createElement("link");
        themeLink.id = "theme-css";
        themeLink.rel = "stylesheet";
        themeLink.type = "text/css";
        head.appendChild(themeLink);
    }
    return themeLink;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CustomMenuComponent, SubMenu, CmxMenuModule, ObserveType, ImagesObserver, LazySrcDirective, LazySrcDirectiveCoreModule, DynamicComponent, CmxDynamicModule, DynamicComponentService, LoaderComponent, LoaderModule, PanelComponent, PanelModule, BroadcasterService, WithEventSubscriptions, DynamicActionsService, AppConfigService, PrivateApiCallerService, generateRequestOptions, PublicApiCallerService, isMobile, recursiveLoop, getThemeById, changeTheme, detectThemeByDeviceType, getCurrentTheme, ThemeList };

//# sourceMappingURL=custom-component.js.map