import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
export declare class PrivateApiCallerService {
    http: HttpClient;
    accessTokenName: string;
    apiUrl: string;
    constructor(http: HttpClient);
    getAuthHeaders(): {
        headers: {
            'Content-Type': string;
            'Authorization': string;
        };
    };
    doPrivateApiRequest(requestFunc: any): Observable<{}>;
    get<T>(endpoint: string, params?: any, reqOpts?: any): Observable<any>;
    post<T>(endpoint: string, body: any, reqOpts?: any): Observable<any>;
    put<T>(endpoint: string, body: any, reqOpts?: any): Observable<any>;
    delete<T>(endpoint: string, reqOpts?: any): Observable<any>;
    patch<T>(endpoint: string, body: any, reqOpts?: any): Observable<any>;
    processApiResponse<T>(): (httpResponse$: Observable<any>) => Observable<T>;
}
